if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface WebView_Params {
    message?: string;
    webviewController?: webview.WebviewController;
    _urlString?: string;
    _view_file?: boolean;
}
import webview from "@ohos:web.webview";
import router from "@ohos:router";
import uri from "@ohos:uri";
import type common from "@ohos:app.ability.common";
import type OpenLinkOptions from "@ohos:app.ability.OpenLinkOptions";
import type { BusinessError } from "@ohos:base";
class WebView extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__message = new ObservedPropertySimplePU('Hello World', this, "message");
        this.webviewController = new webview.WebviewController();
        this._urlString = (router.getParams() as routerParams).url;
        this._view_file = (router.getParams() as routerParams).view_file;
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: WebView_Params) {
        if (params.message !== undefined) {
            this.message = params.message;
        }
        if (params.webviewController !== undefined) {
            this.webviewController = params.webviewController;
        }
        if (params._urlString !== undefined) {
            this._urlString = params._urlString;
        }
        if (params._view_file !== undefined) {
            this._view_file = params._view_file;
        }
    }
    updateStateVars(params: WebView_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__message.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__message.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __message: ObservedPropertySimplePU<string>;
    get message() {
        return this.__message.get();
    }
    set message(newValue: string) {
        this.__message.set(newValue);
    }
    private webviewController: webview.WebviewController;
    // 当前加载的链接
    private _urlString: string;
    private _view_file: boolean;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.debugLine("entry/src/main/ets/pages/WebView.ets(18:5)", "entry");
            Column.height('100%');
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            // 资源文件route.html存放路径src/main/resources/rawfile
            Web.create({ src: this._urlString, controller: this.webviewController });
            Web.debugLine("entry/src/main/ets/pages/WebView.ets(20:7)", "entry");
            // 资源文件route.html存放路径src/main/resources/rawfile
            Web.domStorageAccess(true);
            // 资源文件route.html存放路径src/main/resources/rawfile
            Web.javaScriptAccess(true);
            // 资源文件route.html存放路径src/main/resources/rawfile
            Web.fileAccess(true);
            // 资源文件route.html存放路径src/main/resources/rawfile
            Web.onLoadIntercept((event) => {
                console.log("pj", "========event=============>" + event);
                if (event) {
                    let url: string = event.data.getRequestUrl();
                    console.log("pj", "=====================>" + url);
                    if (url == null) {
                        return;
                    }
                    const uriInstance = new uri.URI(url);
                    console.log("pj", "=========666666==协议是https/http" + uriInstance.scheme);
                    if (uriInstance.scheme == 'https' || uriInstance.scheme == 'http') {
                        console.log("pj", "===========协议是https/http");
                        return false;
                    }
                    else if (uriInstance.scheme == 'js' || uriInstance.scheme == 'jsbridge') {
                        console.log("pj", "===========协议是js");
                        //router.pushUrl({ url: url.substring(9) });
                        return true; //true时便不在加载
                    }
                    else if (uriInstance.scheme == 'alipays') {
                        console.log("pj", "===========跳转到支付宝" + url);
                        // const pullUpApplication = (context: common.UIAbilityContext) => {
                        //   const link = url//'https://appgallery.huawei.com/app/detail?id=com.huawei.hmsapp.books';
                        //   context.openLink(link);
                        // }
                        let context = getContext(this) as common.UIAbilityContext;
                        let link: string = url;
                        let openLinkOptions: OpenLinkOptions = {
                            appLinkingOnly: false
                        };
                        context.openLink(link, openLinkOptions, (err, result) => {
                            console.log("pj", "=========================>" + JSON.stringify(err));
                            console.log("pj", "=========================>" + JSON.stringify(result.resultCode));
                            console.log("pj", "=========================>" + JSON.stringify(result.want));
                        }).then(() => {
                            console.log("pj", "==================open link success=======>");
                        }).catch((err: BusinessError) => {
                            console.log("pj", "==================open link failed, errCode=======>" + JSON.stringify(err.code));
                        });
                        return false;
                    }
                }
                return false;
            });
        }, Web);
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "WebView";
    }
}
class routerParams {
    'url': string;
    'view_file': boolean;
}
if (getPreviewComponentFlag()) {
    storePreviewComponents(1, "WebView", new WebView(undefined, {}));
    previewComponent();
}
else {
    registerNamedRoute(() => new WebView(undefined, {}), "", { bundleName: "com.example.hongmengdemo", moduleName: "entry", pagePath: "pages/WebView", pageFullPath: "entry/src/main/ets/pages/WebView", integratedHsp: "false" });
}
