package com.tsign.realsigndemo


import android.content.Intent
import android.net.Uri
import android.os.Bundle
import android.widget.Toast
import androidx.activity.ComponentActivity
import com.tsign.realsigndemo.databinding.MainActivityBinding

class MainActivity : ComponentActivity() {
    private lateinit var binding : MainActivityBinding
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = MainActivityBinding.inflate(layoutInflater)
        setContentView(binding.root)

        binding.etInput.setText("")

        binding.btnJump.setOnClickListener {
            var url = binding.etInput.text.toString()

            if (url?.isEmpty()){
                Toast.makeText(this,"请输入签署/认证链接",Toast.LENGTH_SHORT).show()
                return@setOnClickListener
            }
            var intent = Intent(this,H5Activity::class.java)
            intent.putExtra("url",url)
            startActivity(intent)
        }

        binding.btnClear.setOnClickListener {
            binding.etInput.setText("")
        }
    }
}