//
//  AppDelegate.m
//  FaceAuthDemo
//
//  Created by tsign on 2019/3/25.
//  Copyright © 2019 tsign. All rights reserved.
//

#import "AppDelegate.h"
#import "SecondViewController.h"
#import "ControllerHelper.h"
#import "Constants.h"
@interface AppDelegate ()

@end

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    [[NSHTTPCookieStorage sharedHTTPCookieStorage] setCookieAcceptPolicy:NSHTTPCookieAcceptPolicyAlways];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation {

    return YES;
}

#if __IPHONE_OS_VERSION_MAX_ALLOWED >= 90000
- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<NSString *, id> *)options {
    NSLog(@"--------> %@",url.absoluteString);
    NSString *urlString = url.absoluteString;
    if ([urlString hasPrefix:REALNAME_CALLBACK] || [urlString hasPrefix:SIGN_CALLBACK]) {
        // 实名和签署意愿 支付宝回调的处理是一致的
        UIViewController *curCtrl = [ControllerHelper findCurrentViewController];
        if ([curCtrl isKindOfClass:[SecondViewController class]]) {
            if ([urlString containsString:@"realnameUrl="]) { // 实名或意愿回来
                NSString *strParam = [urlString substringFromIndex:[urlString rangeOfString:@"?"].location + 1];
                NSString *callbackUrlEncoded = [strParam substringFromIndex:[strParam rangeOfString:@"realnameUrl="].location + @"realnameUrl=".length];
                NSString *callbackUrl = (__bridge_transfer NSString *)CFURLCreateStringByReplacingPercentEscapesUsingEncoding(NULL, (__bridge CFStringRef)callbackUrlEncoded, CFSTR(""), CFStringConvertNSStringEncodingToEncoding(NSUTF8StringEncoding));
                SecondViewController *ctrl = (SecondViewController *) curCtrl;
                [ctrl reloadUrl:callbackUrl];
            }
        } else {
            // 纯api实名接口(跳转支付宝返回的) 接口不会带realnameUrl回来 需要调接口查询实名结果
        }
    }
    return YES;
}
#endif
@end
